
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>


#define TYPE_TREE1 (tree1_get_type ())
#define TREE1(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TREE1, tree1))
#define TREE1_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TREE1, tree1Class))
#define IS_TREE1(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TREE1))
#define IS_TREE1_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TREE1))
#define TREE1_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TREE1, tree1Class))

typedef struct _tree1 tree1;
typedef struct _tree1Class tree1Class;
typedef struct _tree1Private tree1Private;

struct _tree1 {
	GTypeInstance parent_instance;
	volatile int ref_count;
	tree1Private * priv;
	GtkTreeView* tree;
	GtkTreeStore* store1;
	GdkPixbuf* pixbuf1;
};

struct _tree1Class {
	GTypeClass parent_class;
	void (*finalize) (tree1 *self);
};



extern tree1* treeclass1;
tree1* treeclass1 = NULL;
extern tree1* treeclass2;
tree1* treeclass2 = NULL;
extern char* ret0;
char* ret0 = NULL;
gpointer tree1_ref (gpointer instance);
void tree1_unref (gpointer instance);
GParamSpec* param_spec_tree1 (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_tree1 (GValue* value, gpointer v_object);
gpointer value_get_tree1 (const GValue* value);
GType tree1_get_type (void);
void tree1_row_expanded (GtkTreeIter* iter, const GtkTreePath* path);
void tree1_row_collapsed (GtkTreeIter* iter, const GtkTreePath* path);
gboolean tree1_click (const GdkEventButton* button);
void tree2_row_expanded (GtkTreeIter* iter, const GtkTreePath* path);
void tree2_row_collapsed (GtkTreeIter* iter, const GtkTreePath* path);
static void _gtk_main_quit_gtk_object_destroy (GtkWindow* _sender, gpointer self);
tree1* tree1_new (void);
tree1* tree1_construct (GType object_type);
GtkWidget* tree1_tree1 (tree1* self);
GtkTreeIter tree1_add_root_item (tree1* self, const char* text);
GtkTreeIter tree1_add_item (tree1* self, const char* text, GtkTreeIter* parent);
static gboolean _tree1_click_gtk_widget_button_release_event (GtkTreeView* _sender, const GdkEventButton* event, gpointer self);
static void _tree2_row_expanded_gtk_tree_view_row_expanded (GtkTreeView* _sender, GtkTreeIter* iter, const GtkTreePath* path, gpointer self);
static void _tree2_row_collapsed_gtk_tree_view_row_collapsed (GtkTreeView* _sender, GtkTreeIter* iter, const GtkTreePath* path, gpointer self);
void _main (char** args, int args_length1);



/*-- action: a line in the tree1 was expanded --*/
void tree1_row_expanded (GtkTreeIter* iter, const GtkTreePath* path) {
	char* ret;
	g_return_if_fail (path != NULL);
	ret = g_strdup ("");
	gtk_tree_model_get ((GtkTreeModel*) treeclass1->store1, &(*iter), 1, &ret, -1);
	g_print ("expanded: %s\n", ret);
	g_print ("path: %s\n", gtk_tree_path_to_string (path));
	ret = (g_free (ret), NULL);
}


/*-- action: a line in the tree1 was collapsed --*/
void tree1_row_collapsed (GtkTreeIter* iter, const GtkTreePath* path) {
	char* ret;
	g_return_if_fail (path != NULL);
	ret = g_strdup ("");
	gtk_tree_model_get ((GtkTreeModel*) treeclass1->store1, &(*iter), 1, &ret, -1);
	g_print ("collapsed: %s\n", ret);
	g_print ("path: %s\n", gtk_tree_path_to_string (path));
	ret = (g_free (ret), NULL);
}


/*-- action: a line in tree1 was clicked --*/
gboolean tree1_click (const GdkEventButton* button) {
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* selection;
	GtkTreeIter iter = {0};
	GtkTreeSelection* _tmp1_;
	char* ret;
	gboolean _tmp2_;
	_tmp0_ = NULL;
	selection = (_tmp0_ = gtk_tree_view_get_selection (treeclass1->tree), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	/*selection.get_selected(out treeclass1.store1, out iter)*/
	gtk_tree_selection_get_selected (selection, NULL, &iter);
	_tmp1_ = NULL;
	selection = (_tmp1_ = NULL, (selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL)), _tmp1_);
	ret = g_strdup ("");
	gtk_tree_model_get ((GtkTreeModel*) treeclass1->store1, &iter, 1, &ret0, -1);
	g_print ("selected is: %s\n", ret);
	return (_tmp2_ = FALSE, (selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL)), ret = (g_free (ret), NULL), _tmp2_);
}


/*-- action: a line in the tree1 was expanded --*/
void tree2_row_expanded (GtkTreeIter* iter, const GtkTreePath* path) {
	char* ret;
	g_return_if_fail (path != NULL);
	ret = g_strdup ("");
	gtk_tree_model_get ((GtkTreeModel*) treeclass2->store1, &(*iter), 1, &ret, -1);
	g_print ("expanded: %s\n", ret);
	g_print ("path: %s\n", gtk_tree_path_to_string (path));
	ret = (g_free (ret), NULL);
}


/*-- action: a line in the tree2 was collapsed --*/
void tree2_row_collapsed (GtkTreeIter* iter, const GtkTreePath* path) {
	char* ret;
	g_return_if_fail (path != NULL);
	ret = g_strdup ("");
	gtk_tree_model_get ((GtkTreeModel*) treeclass2->store1, &(*iter), 1, &ret, -1);
	g_print ("collapsed: %s\n", ret);
	g_print ("path: %s\n", gtk_tree_path_to_string (path));
	ret = (g_free (ret), NULL);
}


static void _gtk_main_quit_gtk_object_destroy (GtkWindow* _sender, gpointer self) {
	gtk_main_quit ();
}


static gboolean _tree1_click_gtk_widget_button_release_event (GtkTreeView* _sender, const GdkEventButton* event, gpointer self) {
	return tree1_click (event);
}


static void _tree2_row_expanded_gtk_tree_view_row_expanded (GtkTreeView* _sender, GtkTreeIter* iter, const GtkTreePath* path, gpointer self) {
	tree2_row_expanded (iter, path);
}


static void _tree2_row_collapsed_gtk_tree_view_row_collapsed (GtkTreeView* _sender, GtkTreeIter* iter, const GtkTreePath* path, gpointer self) {
	tree2_row_collapsed (iter, path);
}


/*-- main program --*/
void _main (char** args, int args_length1) {
	GtkWindow* window;
	GtkHBox* hbox;
	tree1* _tmp0_;
	GtkWidget* mytree1;
	GtkTreeIter item1;
	GtkTreeIter item2;
	tree1* _tmp1_;
	GtkWidget* mytree2;
	GtkTreeIter item3;
	GtkTreeIter item4;
	gtk_init (&args_length1, &args);
	window = g_object_ref_sink ((GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL));
	gtk_window_set_default_size (window, 300, 200);
	g_signal_connect ((GtkObject*) window, "destroy", (GCallback) _gtk_main_quit_gtk_object_destroy, NULL);
	hbox = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 1));
	gtk_container_set_border_width ((GtkContainer*) hbox, (guint) 10);
	gtk_box_set_spacing ((GtkBox*) hbox, 10);
	gtk_container_add ((GtkContainer*) window, (GtkWidget*) hbox);
	/*-- create a new tree --*/
	_tmp0_ = NULL;
	treeclass1 = (_tmp0_ = tree1_new (), (treeclass1 == NULL) ? NULL : (treeclass1 = (tree1_unref (treeclass1), NULL)), _tmp0_);
	mytree1 = tree1_tree1 (treeclass1);
	gtk_box_pack_start ((GtkBox*) hbox, mytree1, TRUE, TRUE, (guint) 0);
	item1 = tree1_add_root_item (treeclass1, "test 1");
	item2 = tree1_add_item (treeclass1, "test 2", &item1);
	/*treeclass1.tree.row_expanded += tree1_row_expanded
	treeclass1.tree.row_collapsed += tree1_row_collapsed*/
	g_signal_connect ((GtkWidget*) treeclass1->tree, "button-release-event", (GCallback) _tree1_click_gtk_widget_button_release_event, NULL);
	/*-- create a second tree --*/
	_tmp1_ = NULL;
	treeclass2 = (_tmp1_ = tree1_new (), (treeclass2 == NULL) ? NULL : (treeclass2 = (tree1_unref (treeclass2), NULL)), _tmp1_);
	mytree2 = tree1_tree1 (treeclass2);
	gtk_box_pack_start ((GtkBox*) hbox, mytree2, TRUE, TRUE, (guint) 0);
	item3 = tree1_add_root_item (treeclass2, "test 3");
	item4 = tree1_add_item (treeclass2, "test 4", &item3);
	g_signal_connect (treeclass2->tree, "row-expanded", (GCallback) _tree2_row_expanded_gtk_tree_view_row_expanded, NULL);
	g_signal_connect (treeclass2->tree, "row-collapsed", (GCallback) _tree2_row_collapsed_gtk_tree_view_row_collapsed, NULL);
	gtk_widget_show_all ((GtkWidget*) window);
	gtk_main ();
	(window == NULL) ? NULL : (window = (g_object_unref (window), NULL));
	(hbox == NULL) ? NULL : (hbox = (g_object_unref (hbox), NULL));
	(mytree1 == NULL) ? NULL : (mytree1 = (g_object_unref (mytree1), NULL));
	(mytree2 == NULL) ? NULL : (mytree2 = (g_object_unref (mytree2), NULL));
}


int main (int argc, char ** argv) {
	g_type_init ();
	_main (argv, argc);
	return 0;
}




