
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TREE1 (tree1_get_type ())
#define TREE1(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TREE1, tree1))
#define TREE1_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TREE1, tree1Class))
#define IS_TREE1(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TREE1))
#define IS_TREE1_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TREE1))
#define TREE1_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TREE1, tree1Class))

typedef struct _tree1 tree1;
typedef struct _tree1Class tree1Class;
typedef struct _tree1Private tree1Private;
typedef struct _ParamSpectree1 ParamSpectree1;

struct _tree1 {
	GTypeInstance parent_instance;
	volatile int ref_count;
	tree1Private * priv;
	GtkTreeView* tree;
	GtkTreeStore* store1;
	GdkPixbuf* pixbuf1;
};

struct _tree1Class {
	GTypeClass parent_class;
	void (*finalize) (tree1 *self);
};

struct _ParamSpectree1 {
	GParamSpec parent_instance;
};



gpointer tree1_ref (gpointer instance);
void tree1_unref (gpointer instance);
GParamSpec* param_spec_tree1 (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_tree1 (GValue* value, gpointer v_object);
gpointer value_get_tree1 (const GValue* value);
GType tree1_get_type (void);
enum  {
	TREE1_DUMMY_PROPERTY
};
GtkWidget* tree1_tree1 (tree1* self);
GtkTreeIter tree1_add_root_item (tree1* self, const char* text);
GtkTreeIter tree1_add_item (tree1* self, const char* text, GtkTreeIter* parent);
tree1* tree1_new (void);
tree1* tree1_construct (GType object_type);
tree1* tree1_new (void);
static gpointer tree1_parent_class = NULL;
static void tree1_finalize (tree1* obj);



/*
    //-- action: a line in the tree was clicked --
    def click(button : Gdk.EventButton) : bool

    
        var selection = tree.get_selection()
        //-- multiple lines are more complicated
        //s : GLib.List
        //s = selection.get_selected_rows(out store1)
        //-- http://www.vala-project.org/doc/docu/gtk+-2.0.vapi/Gtk/TreeSelection.htm
    
        iter : TreeIter
        selection.get_selected(out store1, out iter)
        var ret = ""
        store1.get(iter ,1 ,out ret)
    
        print ("selected is: %s" , ret)
        return false


    //-- action: a line in the tree was expanded --
    def row_expanded(iter : TreeIter , path : TreePath)

        var ret = ""
        store1.get(iter ,1 ,out ret)
        print ("expanded: %s" , ret)
    
        print ("path: %s" , path.to_string())

    //-- action: a line in the tree was collapsed --
    def row_collapsed(iter : TreeIter , path : TreePath)

        var ret = ""
        store1.get(iter ,1 ,out ret)
        print ("collapsed: %s" , ret)
    
        print ("path: %s" , path.to_string())
*/
GtkWidget* tree1_tree1 (tree1* self) {
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* selection;
	GtkTreeViewColumn* column;
	GtkCellRendererPixbuf* columnpic;
	GtkImage* image;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp2_;
	GtkCellRendererText* columncell;
	GtkTreeStore* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	/*init
	-- the treeview is the visible container --*/
	_tmp0_ = NULL;
	self->tree = (_tmp0_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), (self->tree == NULL) ? NULL : (self->tree = (g_object_unref (self->tree), NULL)), _tmp0_);
	gtk_tree_view_set_headers_visible (self->tree, TRUE);
	/*vbox.pack_start (new Gtk.Label ("Hello World!"), true, true, 0)
	-- set how many lines can be selected --*/
	_tmp1_ = NULL;
	selection = (_tmp1_ = gtk_tree_view_get_selection (self->tree), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
	gtk_tree_selection_set_mode (selection, (GtkSelectionMode) 1);
	/*0: GTK_SELECTION_NONE
	1: GTK_SELECTION_SINGLE
	2: GTK_SELECTION_BROWSE
	3: GTK_SELECTION_MULTIPLE
	-- add a column to the treeview --*/
	column = g_object_ref_sink (gtk_tree_view_column_new ());
	gtk_tree_view_column_set_title (column, "column title");
	columnpic = g_object_ref_sink ((GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ());
	/*
	    GTK_ICON_SIZE_INVALID,
	    GTK_ICON_SIZE_MENU,
	    GTK_ICON_SIZE_SMALL_TOOLBAR,
	    GTK_ICON_SIZE_LARGE_TOOLBAR,
	    GTK_ICON_SIZE_BUTTON,
	    GTK_ICON_SIZE_DND,
	    GTK_ICON_SIZE_DIALOG
	    
	-- this does not work ?
	var image = new Gtk.Image.from_stock(Gtk.STOCK_DIRECTORY , Gtk.IconSize.BUTTON)
	-- so load from file --*/
	image = g_object_ref_sink ((GtkImage*) gtk_image_new_from_file ("./folder.png"));
	_tmp3_ = NULL;
	_tmp2_ = NULL;
	self->pixbuf1 = (_tmp3_ = (_tmp2_ = gtk_image_get_pixbuf (image), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (self->pixbuf1 == NULL) ? NULL : (self->pixbuf1 = (g_object_unref (self->pixbuf1), NULL)), _tmp3_);
	/*-- short code, but throws a warning --
	var pixbuf1 = new Gdk.Pixbuf.from_file("./folder.png")*/
	columncell = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ());
	gtk_cell_layout_pack_start ((GtkCellLayout*) column, (GtkCellRenderer*) columnpic, FALSE);
	gtk_cell_layout_pack_start ((GtkCellLayout*) column, (GtkCellRenderer*) columncell, TRUE);
	gtk_cell_layout_add_attribute ((GtkCellLayout*) column, (GtkCellRenderer*) columnpic, "pixbuf", 0);
	gtk_cell_layout_add_attribute ((GtkCellLayout*) column, (GtkCellRenderer*) columncell, "text", 1);
	gtk_tree_view_append_column (self->tree, column);
	/*-- the treestore is a model assigned to the treeview , containing the items --    */
	_tmp4_ = NULL;
	self->store1 = (_tmp4_ = gtk_tree_store_new (2, GDK_TYPE_PIXBUF, G_TYPE_STRING, NULL), (self->store1 == NULL) ? NULL : (self->store1 = (g_object_unref (self->store1), NULL)), _tmp4_);
	gtk_tree_view_set_model (self->tree, (GtkTreeModel*) self->store1);
	/*    
	    //-- add some elements to the tree --
	    iter : TreeIter
	    store1.append( out iter,null)
	    store1.set (iter, 0, pixbuf1,1, "item 1")
	 
	    iter2 : TreeIter
	    store1.append( out iter2,iter)
	    store1.set (iter2, 0, pixbuf1,1, "item 2")
	  
	    iter3 : TreeIter
	    store1.append( out iter3,iter2)
	    store1.set (iter3, 0, pixbuf1,1, "item 3")
	
	-- assign the eventhandlers for the tree --
	tree.button_release_event += click
	tree.row_expanded += row_expanded
	tree.row_collapsed += row_collapsed*/
	_tmp5_ = NULL;
	_tmp6_ = NULL;
	return (_tmp6_ = (_tmp5_ = (GtkWidget*) self->tree, (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_)), (selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL)), (column == NULL) ? NULL : (column = (g_object_unref (column), NULL)), (columnpic == NULL) ? NULL : (columnpic = (g_object_unref (columnpic), NULL)), (image == NULL) ? NULL : (image = (g_object_unref (image), NULL)), (columncell == NULL) ? NULL : (columncell = (g_object_unref (columncell), NULL)), _tmp6_);
}


GtkTreeIter tree1_add_root_item (tree1* self, const char* text) {
	GtkTreeIter iter = {0};
	gtk_tree_store_append (self->store1, &iter, NULL);
	gtk_tree_store_set (self->store1, &iter, 0, self->pixbuf1, 1, text, -1);
	return iter;
}


GtkTreeIter tree1_add_item (tree1* self, const char* text, GtkTreeIter* parent) {
	GtkTreeIter iter = {0};
	gtk_tree_store_append (self->store1, &iter, &(*parent));
	gtk_tree_store_set (self->store1, &iter, 0, self->pixbuf1, 1, text, -1);
	return iter;
}


tree1* tree1_construct (GType object_type) {
	tree1* self;
	self = (tree1*) g_type_create_instance (object_type);
	return self;
}


tree1* tree1_new (void) {
	return tree1_construct (TYPE_TREE1);
}


static void value_tree1_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_tree1_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		tree1_unref (value->data[0].v_pointer);
	}
}


static void value_tree1_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = tree1_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_tree1_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_tree1_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		tree1* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = tree1_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_tree1_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	tree1** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = tree1_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_tree1 (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpectree1* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TREE1), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_tree1 (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TREE1), NULL);
	return value->data[0].v_pointer;
}


void value_set_tree1 (GValue* value, gpointer v_object) {
	tree1* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TREE1));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TREE1));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		tree1_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		tree1_unref (old);
	}
}


static void tree1_class_init (tree1Class * klass) {
	tree1_parent_class = g_type_class_peek_parent (klass);
	TREE1_CLASS (klass)->finalize = tree1_finalize;
}


static void tree1_instance_init (tree1 * self) {
	self->ref_count = 1;
}


static void tree1_finalize (tree1* obj) {
	tree1 * self;
	self = TREE1 (obj);
	(self->tree == NULL) ? NULL : (self->tree = (g_object_unref (self->tree), NULL));
	(self->store1 == NULL) ? NULL : (self->store1 = (g_object_unref (self->store1), NULL));
	(self->pixbuf1 == NULL) ? NULL : (self->pixbuf1 = (g_object_unref (self->pixbuf1), NULL));
}


GType tree1_get_type (void) {
	static GType tree1_type_id = 0;
	if (tree1_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_tree1_init, value_tree1_free_value, value_tree1_copy_value, value_tree1_peek_pointer, "p", value_tree1_collect_value, "p", value_tree1_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (tree1Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tree1_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (tree1), 0, (GInstanceInitFunc) tree1_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		tree1_type_id = g_type_register_fundamental (g_type_fundamental_next (), "tree1", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return tree1_type_id;
}


gpointer tree1_ref (gpointer instance) {
	tree1* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void tree1_unref (gpointer instance) {
	tree1* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TREE1_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




