[indent=4]


uses
    Gtk



//----------------------------------

//-- Global variables --

treeclass1 : treeclass
treeclass2 : treeclass
mytree1: TreeView
mytree2: TreeView


//-- action: a line in the tree1 was expanded --

def tree1_row_expanded(iter : TreeIter , path : TreePath)

    var ret = ""
    treeclass1.store.get(iter ,1 ,out ret)

    print ("expanded: %s" , ret)    
    print ("path: %s" , path.to_string())

     
//-- action: a line in the tree1 was collapsed --

def tree1_row_collapsed(iter : TreeIter , path : TreePath)

    var ret = ""

    treeclass1.store.get(iter ,1 ,out ret)

    print ("collapsed: %s" , ret)    
    print ("path: %s" , path.to_string())


//-- action: a line in tree1 was clicked --

def tree1_row_click() 

    var ret = treeclass1.tree_click(mytree1)
    print ("selected is: %s" , ret)


    
//-- action: a line in the tree2 was expanded --

def tree2_row_expanded(iter : TreeIter , path : TreePath)

    var ret = ""
    treeclass2.store.get(iter ,1 ,out ret)
    print ("expanded: %s" , ret)    
    print ("path: %s" , path.to_string()) 

//-- action: a line in the tree2 was collapsed --

def tree2_row_collapsed(iter : TreeIter , path : TreePath)

    var ret = ""
    treeclass2.store.get(iter ,1 ,out ret)
    print ("collapsed: %s" , ret)    
    print ("path: %s" , path.to_string())


//-- action: a line in tree2 was clicked --

def tree2_row_click() 

    var ret = treeclass2.tree_click(mytree2)
    print ("selected is: %s" , ret)



//-- main program --

init


    Gtk.init (ref args)

    var window = new Gtk.Window (Gtk.WindowType.TOPLEVEL)
    window.set_default_size (300, 200)
    window.destroy += Gtk.main_quit
    

    var hbox = new Gtk.HBox(false , 1) 
    hbox.border_width = 10 
    hbox.spacing = 10 
    window.add (hbox) 


    //-- create a new tree --
    
    treeclass1 = new treeclass()
    mytree1 = treeclass1.treeview()
    hbox.pack_start (mytree1, true, true, 0); 
    

    var item_A1 = treeclass1.add_root_item("test A1" )
    var item_A2 = treeclass1.add_item("test A2" , item_A1)
    treeclass1.set_image("text.png")
    var item_A3 = treeclass1.add_item("test A3" , item_A2)   
    var item_A4 = treeclass1.add_item("test A4" , item_A2)
      
    treeclass1.tree.row_expanded += tree1_row_expanded
    treeclass1.tree.row_collapsed += tree1_row_collapsed
    Signal.connect_after (treeclass1.tree, "button_release_event", tree1_row_click, null); 
       
       
    //-- create a second tree --

    treeclass2 = new treeclass()
    mytree2 = treeclass2.treeview()
    hbox.pack_start (mytree2, true, true, 0); 
    
    var item_B1 = treeclass2.add_root_item("test B1" )
    var item_B2 = treeclass2.add_item("test B2" , item_B1)
    var item_B3 = treeclass2.add_item("test B3" , item_B2)   

        
    treeclass2.tree.row_expanded += tree2_row_expanded  
    treeclass2.tree.row_collapsed += tree2_row_collapsed
    Signal.connect_after (treeclass2.tree, "button_release_event", tree2_row_click, null); 
    
        
    window.show_all ()

    Gtk.main ()


