[indent=4]

uses
    Gtk


class treeclass


    //-- global variables, so we can use them in the eventhandlers --
    tree : TreeView
    store : TreeStore
    pixbuf1: Gdk.Pixbuf
    imagefile : string


    def tree_click(thetree : Gtk.TreeView) : string

        var selection = thetree.get_selection()
        iter : TreeIter

        //selection.get_selected(out treeclass1.store1, out iter)


        var rows = selection.get_selected_rows(null)
        if rows.length() is 0
            return ""
        selection.get_selected(null, out iter)
    
        var ret = ""
        thetree.model.get( iter ,1 ,out ret)
        return (ret)


/*

    
        var selection = tree.get_selection()
        //-- multiple lines are more complicated
        //s : GLib.List
        //s = selection.get_selected_rows(out store1)
        //-- http://www.vala-project.org/doc/docu/gtk+-2.0.vapi/Gtk/TreeSelection.htm
    

*/



    def treeview() : TreeView

        //-- the treeview is the visible container --
        tree = new TreeView ()
        tree.set_headers_visible (true);

    
        //-- set how many lines can be selected --
        var selection = tree.get_selection()
        selection.set_mode((SelectionMode)1)
        
        //0: GTK_SELECTION_NONE
        //1: GTK_SELECTION_SINGLE
        //2: GTK_SELECTION_BROWSE
        //3: GTK_SELECTION_MULTIPLE
    
    
        //-- add a column to the treeview --
        var column = new TreeViewColumn ()
        column.set_title ("column title")


        var columnpic = new CellRendererPixbuf ()




    /*
    GTK_ICON_SIZE_INVALID,
    GTK_ICON_SIZE_MENU,
    GTK_ICON_SIZE_SMALL_TOOLBAR,
    GTK_ICON_SIZE_LARGE_TOOLBAR,
    GTK_ICON_SIZE_BUTTON,
    GTK_ICON_SIZE_DND,
    GTK_ICON_SIZE_DIALOG
    */
    
        //-- this does not work ?
        //var image = new Gtk.Image.from_stock(Gtk.STOCK_DIRECTORY , Gtk.IconSize.BUTTON)

        //-- so load from file --
        var image = new Gtk.Image.from_file("./folder.png")
        pixbuf1 = image.get_pixbuf()

        //-- short code, but throws a warning --
        //var pixbuf1 = new Gdk.Pixbuf.from_file("./folder.png")
    
        var columncell = new CellRendererText ()

        column.pack_start(columnpic,false)    
        column.pack_start(columncell,true)


        column.add_attribute (columnpic, "pixbuf", 0);
        column.add_attribute(columncell, "text" , 1)
        tree.append_column (column)

        //-- the treestore is a model assigned to the treeview , containing the items --    
        store = new TreeStore (2,typeof(Gdk.Pixbuf), typeof (string));
        tree.set_model(store);
    
        return tree
        
    def set_image(thefile : string)
        var image = new Gtk.Image.from_file(thefile)
        pixbuf1 = image.get_pixbuf()
        

    def add_root_item (text : string) : TreeIter
        iter : TreeIter
        store.append( out iter,null)
        store.set (iter, 0, pixbuf1,1, text)    
        return iter

    def add_item (text : string , parent : TreeIter) : TreeIter
        iter : TreeIter
        store.append( out iter,parent)
        store.set (iter, 0, pixbuf1,1, text)    
        return iter
